質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

87.80%

【Swift】実機でのエラー dyld: Library not loaded:

解決済

回答 1

投稿

  • 評価
  • クリップ 2
  • VIEW 3,179

score 29

発生している問題・エラーメッセージ

実機でビルドしようとすると下記エラーが発生してしまいます。シミュレータでは問題なくビルド通ります。
実機をiOS13.3.1にアップデートしてからこのエラーが発生するようになりました。
どなたか解決策ご教示いただけないでしょうか?

dyld: Library not loaded: @rpath/Charts.framework/Charts
# Uncomment the next line to define a global platform for your project
  # platform :ios, '13.2'
target 'プロジェクト名' do
  # Comment the next line if you don't want to use dynamic frameworks
  use_frameworks!
  # use_modular_headers!

  # Pods for プロジェクト名

pod 'RxSwift'
pod 'RxCocoa'
pod 'XLPagerTabStrip'
pod 'Charts'
pod 'SVProgressHUD'
pod 'Firebase/Core'
pod 'Firebase/Firestore'
pod 'FirebaseFirestoreSwift'
pod 'Firebase/Auth'
pod 'Firebase/Analytics'
pod 'Fabric', '~> 1.10.2'
pod 'Crashlytics', '~> 3.14.0'

end

試したこと

この記事を参考に、Podfileでuse_frameworks!use_modular_headers!に変更。
→下記エラーが発生してしまう。

module map file '/Users/プロジェクトまでのPath/Pods/Headers/Private/openssl_grpc/BoringSSL-GRPC.modulemap' not found

補足情報(FW/ツールのバージョンなど)

Xcode:11.3.1
実機のバージョン:iOS13.3.1

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • hoshi-takanori

    2020/03/03 08:24

    Firestore が使ってる BoringSSL というライブラリが use_frameworks! じゃないとダメとか言ってますね。
    https://github.com/firebase/firebase-ios-sdk/issues/3816

    キャンセル

  • duck015

    2020/03/03 14:48

    コメントありがとうございます。
    Firestoreを使う場合は、use_frameworks!じゃないとダメなんですね。
    現状、TakeOneさんの回答の通り、Apple Developer Programの有償契約アカウントでビルドするのがいいみたいです...。

    キャンセル

回答 1

checkベストアンサー

+3

次の条件で、現在実機テストが失敗する現象を確認しています。

  • iOS13.3.1の実機を使用
  • フレームワーク化されたダイナミックリンクの外部ライブラリを使用
  • 無償アカウントでビルド

参考 : https://stackoverflow.com/questions/60096258/library-not-loaded-rpath-fblpromises-framework-fblpromises-ios-13-3-1/60211703

iOS13.3.1以降、Appleは無償アカウントでの実機利用を不可にしたのではないかという人もいますが、私としては、おそらくこれはAppleのバグで、いずれ修正されるのではないかと思います。ただ、今のところAppleからの公式なアナウンスは何もないので、推測でしかありません。無償アカウントを使った場合の話なので、放置されてしまう可能性もあると思います。

回避策としては、以下の案があります。

(案1) iOS13.3以前の実機を使用する。
iOS13.3.1をiOS13.3にダウングレードすればよいという話も以前はありましたが、
2月13日以降、AppleはiOS13.3の署名を停止したため、現在は既にダウングレードできなくなっています。

参考: https://sbapp.net/appnews/app/upinfo/ios13/syomei-teishi-shsh-111540

(案2) CocoaPodsでライブラリをインストールする際、use_frameworks!の指定の代わりにmodular_headers!を指定する。(または単純にuse_frameworks!を削除する。)
これによって、外部ライブラリがスタティックリンクされ、問題を回避できる場合がありますが、use_frameworks!指定が必須のライブラリもありますので、全てのライブラリでこの方法が通用するわけではありません。Firestoreを使いたい場合は、この方法は使えません。

(案3) Apple Developer Programの有償契約アカウントでビルドする。
年間11,800円の契約料が必要ですが、AppStoreからアプリをリリースするつもりでやっているのだったら、いずれ必要になるので、この方法が一番確実だと思います。


(3/26追記)

3/25にiOS13.4とXcode11.4がリリースされました。
これらを使用することで、この問題は解消されたようです。

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2020/03/03 14:49

    コメントありがとうございます!
    Firesotreを使う場合は、Apple Developer Programの有償契約アカウントでビルドするしかないということですね...。リリースするつもりで作成していたので、(案3)の方向で進めていきたいと思います。
    ありがとうございました!

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 87.80%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る